#!/bin/sh

REL=e.25.46ml

if [ "x$1" = "x" ] || ( [ ! "$1" = "i686" ] && [ ! "$1" = "i686smp" ] \
  && [ ! "$1" = "i686BOOT" ] && [ ! "$1" = "i686enterprise" ] \
  && [ ! "$1" = "i686debug" ] ); then
    echo "usage:"
    echo "    sh $0 i686|i686smp|i686BOOT|i686enterprise|i686debug"
    exit 0
fi

case $1 in
    *smp)	TYPE="smp"; ARCH=`echo $1 | sed -e 's/smp//'` ;;
    *BOOT)	TYPE="BOOT"; ARCH=`echo $1 | sed -e 's/BOOT//'` ;;
    *enterprise)TYPE="enterprise"; ARCH=`echo $1 | sed -e 's/enterprise//'` ;;
    *debug)	TYPE="debug"; ARCH=`echo $1 | sed -e 's/debug//'` ;;
    *)		TYPE=""; ARCH=$1 ;;
esac

make -s mrproper
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -$REL$TYPE/" Makefile
cp configs/kernel-*-$ARCH${TYPE:+\-$TYPE}.config .config
make -s oldconfig_nonint
make -s dep
make -s include/linux/version.h

echo Done...
