#include <stdio.h>
#include <linux/types.h>
#include <sys/errno.h>

struct aac_query_disk
{
	__s32	cnum;
	__s32	bus;
	__s32	id;
	__s32	lun;
	__u32	valid;
	__u32	locked;
	__u32	deleted;
	__s32	instance;
	__s8	name[10];
	__u32	unmapped;
};

#define FSACTL_QUERY_DISK			0x173

int
main(int argc, char ** argv)
{
	struct aac_query_disk qd;
	int cid, retval;

	for (cid = 0; cid < 64; ++cid) {
		memset (&qd, -1, sizeof(qd));
		qd.cnum = cid;
		retval = ioctl(fileno(stdin), FSACTL_QUERY_DISK, &qd);
		printf (
		  "/dev/%.10s (%d,%d,%d,%d) c%d valid=%d locked=%d deleted=%d unmapped=%d ret=%d errno=%d\n",
		  ((qd.name[0] == -1) ? "???" : (char *)qd.name),
		  qd.instance, qd.bus, qd.id, qd.lun,
		  qd.cnum,
		  qd.valid, qd.locked, qd.deleted, qd.unmapped,
		  retval, errno);
	}
	return 0;
}
