/* $Id: lkst.h,v 1.2 2002/03/25 19:05:13 serizawa Exp $ */
/* linux/include/asm-i386/lkst.h */

/************************************************************
 *
 * COPYRIGHT (C) HITACHI,LTD. 2002 ALL RIGHTS RESERVED.
 * WRITTEN BY HITACHI SYSTEMS DEVELOPMENT LABORATORY,
 *            HITACHI CENTRAL RESEARCH LABORATORY.
 *
 * Created by T.Nakamura <tetsu@crl.hitachi.co.jp>
 *
 ************************************************************/

#ifndef _ARCH_I386_LKST_H
#define _ARCH_I386_LKST_H

#ifdef __KERNEL__
#include <asm/timex.h>		/* for cpu_khz */
#endif /* #ifndef __KERNEL__ */

#define LKST_BIG_ENDIAN	0

	//TODO: LKST_ARGP()'s shift
	/* LKST_ARGP converts a pointer into lkst_arg_t. */
#define LKST_ARGP_S(ptr)							\
	((lkst_arg_t) ((unsigned int)(ptr) << 32))
#define LKST_ARGP(ptr)							\
	((lkst_arg_t) ((unsigned int)(ptr)))

	/* This is ugly fix for arch/i386/boot/compressed/misc.c */
#ifdef LKST_SUPPRESS_PIO_TRACE

#define LKST_ENTRY_LOG_PIO_OUT(portaddr,bw,val,calladdr)
#define LKST_ENTRY_LOG_PIO_IN(portaddr,bw,val,calladdr)

#else  /* i.e., !ifdef LKST_SUPPRESS_PIO_TRACE */

#define LKST_ENTRY_LOG_PIO_OUT(portaddr,bw,val,calladdr)\
  LKST_HOOK_INLINE(LKST_ETYPE_O_PORTOUT, LKST_ARG32(portaddr,bw),\
		LKST_ARG32(val,0), LKST_ARGP(calladdr), 0);
#define LKST_ENTRY_LOG_PIO_IN(portaddr,bw,val,calladdr)\
  LKST_HOOK_INLINE(LKST_ETYPE_O_PORTIN, LKST_ARG32(portaddr,bw),\
		LKST_ARG32(val,0), LKST_ARGP(calladdr), 0);

#endif /* ifdef LKST_SUPPRESS_PIO_TRACE */

typedef	unsigned long	lkst_cpu_freq_t;
typedef	u_int64_t 	lkst_tsc_t;

#endif /* _ARCH_I386_LKST_H */
